// TribeBots
// last update: 05.03.2015
// dev.hacklabetrni.org

#include <IRremote.h>
#include <IRremoteInt.h>

/*
 * IRremote: IRrecvDemo - demonstrates receiving IR codes with IRrecv
 * An IR detector/demodulator must be connected to the input RECV_PIN.
 * Version 0.1 July, 2009
 * Copyright 2009 Ken Shirriff
 * http://arcfn.com
 */
 

int RECV_PIN = 11;

IRrecv irrecv(RECV_PIN);
IRsend irsend;

boolean right;
boolean left;
boolean stopped;
boolean play_1;
boolean play_2;

boolean ch_free; // Canale libero o occupato

unsigned long previousMillis = 0;
unsigned long previousMillis_2 = 0;
const long interval = 8000; // Ogni 8 sec TX  
const long interval_2 = 10000; // Tempo durata stato agitato

// RGB Led Control
const int yellowLEDPin = 9;    // LED connected to digital pin 9
const int redLEDPin = 8;     // LED connected to digital pin 8
const int blueLEDPin = 7; 

decode_results results;

void setup()
{
  //Serial.begin(9600);
  irrecv.enableIRIn(); // Start the receiver
  
  pinMode(10, OUTPUT); // Motor 2
  pinMode(5, OUTPUT); // Motor 1
  pinMode(13, OUTPUT); //Led (opzionale)
  
  // pin RGB Led
  pinMode(yellowLEDPin,OUTPUT);
  pinMode(redLEDPin,OUTPUT);
  pinMode(blueLEDPin,OUTPUT);

 ch_free = true;
}

void loop() {
  
  
  
 if (left) {
          analogWrite(5, 100);
          analogWrite(10, 0);
 }
 else if (right) {
          analogWrite(10, 100);
          analogWrite(5, 0);
 }
 else if (stopped) {
          analogWrite(10, 0);
          analogWrite(5, 0);
}
else if (play_1) { //calmo
          analogWrite(10, 50);
          analogWrite(5, 50);
}
else if (play_2) { //agitato
          analogWrite(10, 110);
          analogWrite(5, 110);
}
  
  
  unsigned long currentMillis = millis();
 
  if( (currentMillis - previousMillis >= interval) && ch_free == false) {
        previousMillis = currentMillis; 
        ch_free = true;   
   }
  
      // Durata di 10 sec. per stato agitato, dopo 10 sec. torna calmo
      if( (currentMillis - previousMillis_2 >= interval_2) && play_2 == true) {
          previousMillis_2 = currentMillis; 
          play_2 = false;   
          play_1 = true;
          Serial.println(currentMillis);
      }
  
  
  // Se il canale è libero LED Verde altrimenti ROSSO
  if (ch_free) {
      digitalWrite(redLEDPin, HIGH);
      digitalWrite(yellowLEDPin, LOW);
      digitalWrite(blueLEDPin, HIGH);
  } else {
      digitalWrite(redLEDPin, LOW);
      digitalWrite(yellowLEDPin, HIGH);
      digitalWrite(blueLEDPin, HIGH);
  }
     
  // Ricezione dati IR
  if (irrecv.decode(&results)) {
    
    ch_free = false;
    
    
      //Serial.println(results.value, HEX);
      
      // Led rosso quando si ricevono dati
      digitalWrite(redLEDPin, HIGH);
      digitalWrite(yellowLEDPin, LOW);
      digitalWrite(blueLEDPin, LOW);   

    switch(results.value) {
    
        //Alcuni codici sono inviati da telecomando SONY
        case (0x39C): // Vai a destra  FF BUTTON
          left = false;
          right = true;
          stopped = false;
          play_1 = false;
          break;
        case (0xD9C): // Vai a sinistra REW BUTTON
          left = true;
          right = false;
          stopped = false;
          play_1 = false;
          break;
        case (0x19C): // stop  STOP BUTTON
          left = false;
          right = false;
          stopped = true;
          play_1 = false;
          break;
        case (0x59C): // movimento tranquillo PLAY BUTTON
          play_1 = true;
          stopped = false;
          left = false;
          right = false;
//            digitalWrite(redLEDPin, HIGH);
//            digitalWrite(yellowLEDPin, LOW);
//            digitalWrite(blueLEDPin, LOW);
          break;
        case (0x4C9D): // movimento agitato RED BUTTON
          play_2 = true;
          play_1 = false;
          stopped = false;
          left = false;
          right = false;
          break;
        case (0xA60): // movimento agitato Ricevuto da un TribeBot "diverso - di un altra Tribù ;-) "
          if (stopped) {break;}
          play_2 = true;
          play_1 = false;
          stopped = false;
          left = false;
          right = false;
          digitalWrite(redLEDPin, HIGH);
          digitalWrite(yellowLEDPin, HIGH);
          digitalWrite(blueLEDPin, HIGH);
          break;
    
    }
        irrecv.resume(); // Receive the next value
  }
  delay(100);
  

   // Trasmetti solo se il canale è libero
   if (ch_free) {

      for (int i = 0; i < 3; i++) {
          irsend.sendSony(0xA70, 12); // Codifica Sony TV power code
          delay(40);
       }
       irrecv.enableIRIn(); // Riabilita la ricezione
       
       ch_free = false;
       
//       digitalWrite(redLEDPin, HIGH);
//       digitalWrite(yellowLEDPin, HIGH);
//       digitalWrite(blueLEDPin, HIGH);
       delay(60);
   }
}
